//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace Tecan.Sila2.Interop.Client.StructureDataTypeTest.StructureDataTypeTest
{
    
    
    /// <summary>
    /// Data transfer object for the request of the Echo Structure Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoStructureValueRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private TestStructureDto _structureValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoStructureValueRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="structureValue">The Structure value to be returned.</param>
        public EchoStructureValueRequestDto(TestStructure structureValue, Tecan.Sila2.IBinaryStore store)
        {
            StructureValue = new TestStructureDto(structureValue, store);
        }
        
        /// <summary>
        /// The Structure value to be returned.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public TestStructureDto StructureValue
        {
            get
            {
                return _structureValue;
            }
            set
            {
                _structureValue = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/StructureDataTypeTest/v1/Command/EchoStructureValue";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(StructureValue, "structureValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(StructureValue, "structureValue"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Echo Structure Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoStructureValueResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private TestStructureDto _receivedValues;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoStructureValueResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="receivedValues">The structure that has been received.</param>
        public EchoStructureValueResponseDto(TestStructure receivedValues, Tecan.Sila2.IBinaryStore store)
        {
            ReceivedValues = new TestStructureDto(receivedValues, store);
        }
        
        /// <summary>
        /// The structure that has been received.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public TestStructureDto ReceivedValues
        {
            get
            {
                return _receivedValues;
            }
            set
            {
                _receivedValues = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ReceivedValues, "receivedValues");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(ReceivedValues, "receivedValues"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Echo Deep Structure Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoDeepStructureValueRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private DeepStructureDto _deepStructureValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoDeepStructureValueRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="deepStructureValue">The deep Structure value to be set.</param>
        public EchoDeepStructureValueRequestDto(DeepStructure deepStructureValue, Tecan.Sila2.IBinaryStore store)
        {
            DeepStructureValue = new DeepStructureDto(deepStructureValue, store);
        }
        
        /// <summary>
        /// The deep Structure value to be set.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public DeepStructureDto DeepStructureValue
        {
            get
            {
                return _deepStructureValue;
            }
            set
            {
                _deepStructureValue = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/StructureDataTypeTest/v1/Command/EchoDeepStructureValue";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(DeepStructureValue, "deepStructureValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(DeepStructureValue, "deepStructureValue"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Echo Deep Structure Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoDeepStructureValueResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private DeepStructureDto _receivedValues;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoDeepStructureValueResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="receivedValues">The structure that has been received.</param>
        public EchoDeepStructureValueResponseDto(DeepStructure receivedValues, Tecan.Sila2.IBinaryStore store)
        {
            ReceivedValues = new DeepStructureDto(receivedValues, store);
        }
        
        /// <summary>
        /// The structure that has been received.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public DeepStructureDto ReceivedValues
        {
            get
            {
                return _receivedValues;
            }
            set
            {
                _receivedValues = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ReceivedValues, "receivedValues");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(ReceivedValues, "receivedValues"));
        }
    }
    
    /// <summary>
    /// The data transfer object for Test Structure
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class TestStructureDto : Tecan.Sila2.ISilaTransferObject<TestStructure>
    {
        
        private InnerStruct _inner;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public TestStructureDto()
        {
            _inner = new InnerStruct();
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public TestStructureDto(TestStructure inner, Tecan.Sila2.IBinaryStore store)
        {
            _inner = new InnerStruct(inner, store);
        }
        
        /// <summary>
        /// A value of SiLA data type String.
        /// </summary>
        public Tecan.Sila2.StringDto StringTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.StringTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.StringTypeValue = value;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Integer.
        /// </summary>
        public Tecan.Sila2.IntegerDto IntegerTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.IntegerTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.IntegerTypeValue = value;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Real.
        /// </summary>
        public Tecan.Sila2.RealDto RealTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.RealTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.RealTypeValue = value;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Boolean.
        /// </summary>
        public Tecan.Sila2.BooleanDto BooleanTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.BooleanTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.BooleanTypeValue = value;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Binary.
        /// </summary>
        public Tecan.Sila2.BinaryDto BinaryTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.BinaryTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.BinaryTypeValue = value;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Date.
        /// </summary>
        public Tecan.Sila2.DateDto DateTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.DateTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.DateTypeValue = value;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Time.
        /// </summary>
        public Tecan.Sila2.TimeDto TimeTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.TimeTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.TimeTypeValue = value;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Timestamp.
        /// </summary>
        public Tecan.Sila2.TimestampDto TimestampTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.TimestampTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.TimestampTypeValue = value;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Any.
        /// </summary>
        public Tecan.Sila2.DynamicClient.AnyTypeDto AnyTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.AnyTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.AnyTypeValue = value;
            }
        }
        
        /// <summary>
        /// The actual contents of the data transfer object.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public InnerStruct Inner
        {
            get
            {
                return _inner;
            }
            set
            {
                _inner = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public TestStructure Extract(Tecan.Sila2.IBinaryStore store)
        {
            return new TestStructure(StringTypeValue.Extract(store), IntegerTypeValue.Extract(store), RealTypeValue.Extract(store), BooleanTypeValue.Extract(store), BinaryTypeValue.Extract(store), DateTypeValue.Extract(store), TimeTypeValue.Extract(store), TimestampTypeValue.Extract(store), AnyTypeValue.Extract(store));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static TestStructureDto Create(TestStructure inner, Tecan.Sila2.IBinaryStore store)
        {
            return new TestStructureDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ((((((((("" + Argument.Require(StringTypeValue, "stringTypeValue")) 
                        + Argument.Require(IntegerTypeValue, "integerTypeValue")) 
                        + Argument.Require(RealTypeValue, "realTypeValue")) 
                        + Argument.Require(BooleanTypeValue, "booleanTypeValue")) 
                        + Argument.Require(BinaryTypeValue, "binaryTypeValue")) 
                        + Argument.Require(DateTypeValue, "dateTypeValue")) 
                        + Argument.Require(TimeTypeValue, "timeTypeValue")) 
                        + Argument.Require(TimestampTypeValue, "timestampTypeValue")) 
                        + Argument.Require(AnyTypeValue, "anyTypeValue"));
        }
        
        /// <summary>
        /// Represents the inner structure for actual content
        /// </summary>
        [ProtoBuf.ProtoContractAttribute()]
        public class InnerStruct
        {
            
            private Tecan.Sila2.StringDto _stringTypeValue;
            
            private Tecan.Sila2.IntegerDto _integerTypeValue;
            
            private Tecan.Sila2.RealDto _realTypeValue;
            
            private Tecan.Sila2.BooleanDto _booleanTypeValue;
            
            private Tecan.Sila2.BinaryDto _binaryTypeValue;
            
            private Tecan.Sila2.DateDto _dateTypeValue;
            
            private Tecan.Sila2.TimeDto _timeTypeValue;
            
            private Tecan.Sila2.TimestampDto _timestampTypeValue;
            
            private Tecan.Sila2.DynamicClient.AnyTypeDto _anyTypeValue;
            
            /// <summary>
            /// Initializes a new instance (to be used by the serializer)
            /// </summary>
            public InnerStruct()
            {
            }
            
            /// <summary>
            /// Initializes a new data transfer object from the business object
            /// </summary>
            /// <param name="inner">The business object that should be transferred</param>
            /// <param name="store">A component to handle binary data</param>
            public InnerStruct(TestStructure inner, Tecan.Sila2.IBinaryStore store)
            {
                StringTypeValue = new Tecan.Sila2.StringDto(inner.StringTypeValue, store);
                IntegerTypeValue = new Tecan.Sila2.IntegerDto(inner.IntegerTypeValue, store);
                RealTypeValue = new Tecan.Sila2.RealDto(inner.RealTypeValue, store);
                BooleanTypeValue = new Tecan.Sila2.BooleanDto(inner.BooleanTypeValue, store);
                BinaryTypeValue = new Tecan.Sila2.BinaryDto(inner.BinaryTypeValue, store);
                DateTypeValue = new Tecan.Sila2.DateDto(inner.DateTypeValue, store);
                TimeTypeValue = new Tecan.Sila2.TimeDto(inner.TimeTypeValue, store);
                TimestampTypeValue = new Tecan.Sila2.TimestampDto(inner.TimestampTypeValue, store);
                AnyTypeValue = new Tecan.Sila2.DynamicClient.AnyTypeDto(inner.AnyTypeValue, store);
            }
            
            /// <summary>
            /// A value of SiLA data type String.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(1)]
            public Tecan.Sila2.StringDto StringTypeValue
            {
                get
                {
                    return _stringTypeValue;
                }
                set
                {
                    _stringTypeValue = value;
                }
            }
            
            /// <summary>
            /// A value of SiLA data type Integer.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(2)]
            public Tecan.Sila2.IntegerDto IntegerTypeValue
            {
                get
                {
                    return _integerTypeValue;
                }
                set
                {
                    _integerTypeValue = value;
                }
            }
            
            /// <summary>
            /// A value of SiLA data type Real.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(3)]
            public Tecan.Sila2.RealDto RealTypeValue
            {
                get
                {
                    return _realTypeValue;
                }
                set
                {
                    _realTypeValue = value;
                }
            }
            
            /// <summary>
            /// A value of SiLA data type Boolean.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(4)]
            public Tecan.Sila2.BooleanDto BooleanTypeValue
            {
                get
                {
                    return _booleanTypeValue;
                }
                set
                {
                    _booleanTypeValue = value;
                }
            }
            
            /// <summary>
            /// A value of SiLA data type Binary.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(5)]
            public Tecan.Sila2.BinaryDto BinaryTypeValue
            {
                get
                {
                    return _binaryTypeValue;
                }
                set
                {
                    _binaryTypeValue = value;
                }
            }
            
            /// <summary>
            /// A value of SiLA data type Date.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(6)]
            public Tecan.Sila2.DateDto DateTypeValue
            {
                get
                {
                    return _dateTypeValue;
                }
                set
                {
                    _dateTypeValue = value;
                }
            }
            
            /// <summary>
            /// A value of SiLA data type Time.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(7)]
            public Tecan.Sila2.TimeDto TimeTypeValue
            {
                get
                {
                    return _timeTypeValue;
                }
                set
                {
                    _timeTypeValue = value;
                }
            }
            
            /// <summary>
            /// A value of SiLA data type Timestamp.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(8)]
            public Tecan.Sila2.TimestampDto TimestampTypeValue
            {
                get
                {
                    return _timestampTypeValue;
                }
                set
                {
                    _timestampTypeValue = value;
                }
            }
            
            /// <summary>
            /// A value of SiLA data type Any.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(9)]
            public Tecan.Sila2.DynamicClient.AnyTypeDto AnyTypeValue
            {
                get
                {
                    return _anyTypeValue;
                }
                set
                {
                    _anyTypeValue = value;
                }
            }
        }
    }
    
    /// <summary>
    /// The data transfer object for Deep Structure
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class DeepStructureDto : Tecan.Sila2.ISilaTransferObject<DeepStructure>
    {
        
        private InnerStruct _inner;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public DeepStructureDto()
        {
            _inner = new InnerStruct();
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public DeepStructureDto(DeepStructure inner, Tecan.Sila2.IBinaryStore store)
        {
            _inner = new InnerStruct(inner, store);
        }
        
        /// <summary>
        /// A value of SiLA data type String contained in the topmost structure.
        /// </summary>
        public Tecan.Sila2.StringDto OuterStringTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.OuterStringTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.OuterStringTypeValue = value;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Integer contained in the topmost structure.
        /// </summary>
        public Tecan.Sila2.IntegerDto OuterIntegerTypeValue
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.OuterIntegerTypeValue;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.OuterIntegerTypeValue = value;
            }
        }
        
        /// <summary>
        /// Another structure type that is part of the outer structure.
        /// </summary>
        public DeepStructureMiddleStructureDto MiddleStructure
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.MiddleStructure;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.MiddleStructure = value;
            }
        }
        
        /// <summary>
        /// The actual contents of the data transfer object.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public InnerStruct Inner
        {
            get
            {
                return _inner;
            }
            set
            {
                _inner = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public DeepStructure Extract(Tecan.Sila2.IBinaryStore store)
        {
            return new DeepStructure(OuterStringTypeValue.Extract(store), OuterIntegerTypeValue.Extract(store), MiddleStructure.Extract(store));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static DeepStructureDto Create(DeepStructure inner, Tecan.Sila2.IBinaryStore store)
        {
            return new DeepStructureDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ((("" + Argument.Require(OuterStringTypeValue, "outerStringTypeValue")) 
                        + Argument.Require(OuterIntegerTypeValue, "outerIntegerTypeValue")) 
                        + Argument.Require(MiddleStructure, "middleStructure"));
        }
        
        /// <summary>
        /// Represents the inner structure for actual content
        /// </summary>
        [ProtoBuf.ProtoContractAttribute()]
        public class InnerStruct
        {
            
            private Tecan.Sila2.StringDto _outerStringTypeValue;
            
            private Tecan.Sila2.IntegerDto _outerIntegerTypeValue;
            
            private DeepStructureMiddleStructureDto _middleStructure;
            
            /// <summary>
            /// Initializes a new instance (to be used by the serializer)
            /// </summary>
            public InnerStruct()
            {
            }
            
            /// <summary>
            /// Initializes a new data transfer object from the business object
            /// </summary>
            /// <param name="inner">The business object that should be transferred</param>
            /// <param name="store">A component to handle binary data</param>
            public InnerStruct(DeepStructure inner, Tecan.Sila2.IBinaryStore store)
            {
                OuterStringTypeValue = new Tecan.Sila2.StringDto(inner.OuterStringTypeValue, store);
                OuterIntegerTypeValue = new Tecan.Sila2.IntegerDto(inner.OuterIntegerTypeValue, store);
                MiddleStructure = new DeepStructureMiddleStructureDto(inner.MiddleStructure, store);
            }
            
            /// <summary>
            /// A value of SiLA data type String contained in the topmost structure.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(1)]
            public Tecan.Sila2.StringDto OuterStringTypeValue
            {
                get
                {
                    return _outerStringTypeValue;
                }
                set
                {
                    _outerStringTypeValue = value;
                }
            }
            
            /// <summary>
            /// A value of SiLA data type Integer contained in the topmost structure.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(2)]
            public Tecan.Sila2.IntegerDto OuterIntegerTypeValue
            {
                get
                {
                    return _outerIntegerTypeValue;
                }
                set
                {
                    _outerIntegerTypeValue = value;
                }
            }
            
            /// <summary>
            /// Another structure type that is part of the outer structure.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(3)]
            public DeepStructureMiddleStructureDto MiddleStructure
            {
                get
                {
                    return _middleStructure;
                }
                set
                {
                    _middleStructure = value;
                }
            }
        }
    }
    
    /// <summary>
    /// The data transfer object for Deep Structure Middle Structure
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class DeepStructureMiddleStructureDto : Tecan.Sila2.ISilaTransferObject<DeepStructureMiddleStructure>
    {
        
        private Tecan.Sila2.StringDto _middleStringTypeValue;
        
        private Tecan.Sila2.IntegerDto _middleIntegerTypeValue;
        
        private DeepStructureMiddleStructureInnerStructureDto _innerStructure;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public DeepStructureMiddleStructureDto()
        {
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public DeepStructureMiddleStructureDto(DeepStructureMiddleStructure inner, Tecan.Sila2.IBinaryStore store)
        {
            MiddleStringTypeValue = new Tecan.Sila2.StringDto(inner.MiddleStringTypeValue, store);
            MiddleIntegerTypeValue = new Tecan.Sila2.IntegerDto(inner.MiddleIntegerTypeValue, store);
            InnerStructure = new DeepStructureMiddleStructureInnerStructureDto(inner.InnerStructure, store);
        }
        
        /// <summary>
        /// A value of SiLA data type String contained in the middle structure.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto MiddleStringTypeValue
        {
            get
            {
                return _middleStringTypeValue;
            }
            set
            {
                _middleStringTypeValue = value;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Integer contained in the middle structure.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(2)]
        public Tecan.Sila2.IntegerDto MiddleIntegerTypeValue
        {
            get
            {
                return _middleIntegerTypeValue;
            }
            set
            {
                _middleIntegerTypeValue = value;
            }
        }
        
        /// <summary>
        /// A structure type that is part of the middle structure.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(3)]
        public DeepStructureMiddleStructureInnerStructureDto InnerStructure
        {
            get
            {
                return _innerStructure;
            }
            set
            {
                _innerStructure = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public DeepStructureMiddleStructure Extract(Tecan.Sila2.IBinaryStore store)
        {
            return new DeepStructureMiddleStructure(MiddleStringTypeValue.Extract(store), MiddleIntegerTypeValue.Extract(store), InnerStructure.Extract(store));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static DeepStructureMiddleStructureDto Create(DeepStructureMiddleStructure inner, Tecan.Sila2.IBinaryStore store)
        {
            return new DeepStructureMiddleStructureDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ((("" + Argument.Require(MiddleStringTypeValue, "middleStringTypeValue")) 
                        + Argument.Require(MiddleIntegerTypeValue, "middleIntegerTypeValue")) 
                        + Argument.Require(InnerStructure, "innerStructure"));
        }
    }
    
    /// <summary>
    /// The data transfer object for Deep Structure Middle Structure Inner Structure
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class DeepStructureMiddleStructureInnerStructureDto : Tecan.Sila2.ISilaTransferObject<DeepStructureMiddleStructureInnerStructure>
    {
        
        private Tecan.Sila2.StringDto _innerStringTypeValue;
        
        private Tecan.Sila2.IntegerDto _innerIntegerTypeValue;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public DeepStructureMiddleStructureInnerStructureDto()
        {
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public DeepStructureMiddleStructureInnerStructureDto(DeepStructureMiddleStructureInnerStructure inner, Tecan.Sila2.IBinaryStore store)
        {
            InnerStringTypeValue = new Tecan.Sila2.StringDto(inner.InnerStringTypeValue, store);
            InnerIntegerTypeValue = new Tecan.Sila2.IntegerDto(inner.InnerIntegerTypeValue, store);
        }
        
        /// <summary>
        /// A value of SiLA data type String contained in the innermost structure.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto InnerStringTypeValue
        {
            get
            {
                return _innerStringTypeValue;
            }
            set
            {
                _innerStringTypeValue = value;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Integer contained in the innermost structure.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(2)]
        public Tecan.Sila2.IntegerDto InnerIntegerTypeValue
        {
            get
            {
                return _innerIntegerTypeValue;
            }
            set
            {
                _innerIntegerTypeValue = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public DeepStructureMiddleStructureInnerStructure Extract(Tecan.Sila2.IBinaryStore store)
        {
            return new DeepStructureMiddleStructureInnerStructure(InnerStringTypeValue.Extract(store), InnerIntegerTypeValue.Extract(store));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static DeepStructureMiddleStructureInnerStructureDto Create(DeepStructureMiddleStructureInnerStructure inner, Tecan.Sila2.IBinaryStore store)
        {
            return new DeepStructureMiddleStructureInnerStructureDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return (("" + Argument.Require(InnerStringTypeValue, "innerStringTypeValue")) 
                        + Argument.Require(InnerIntegerTypeValue, "innerIntegerTypeValue"));
        }
    }
}
